<?php

    include_once( PLOG_CLASS_PATH."class/data/validator/rules/rule.class.php");
    
    define( "DEFAULT_PATTERN_CASE_SENSITIVE", true);

    class FilteredPatternsRule extends Rule
    {
		var $_filteredPatterns;
		
        /**
         * The constructor does nothing.
         */
        function FilteredPatternsRule( $filteredPatterns, $caseSensitive = DEFAULT_PATTERN_CASE_SENSITIVE )
        {
            $this->Rule();

			$this->_caseSensitive = $caseSensitive;
			$this->_filteredPatterns = $filteredPatterns;
        }

        /**
         * Add function info here
         */
        function isCaseSensitive()
        {
            return $this->_caseSensitive;
        }

        /**
         * Add function info here
         */
        function setCaseSensitive( $caseSensitive = DEFAULT_PATTERN_CASE_SENSITIVE )
        {
            $this->_caseSensitive = $caseSensitive;
        }

        /**
		 * validates that none of the pattern in the given string
         */
        function validate($value)
        {
			foreach( $this->_filteredPatterns as $filteredPattern ) {
				$regexp = "/^$filteredPattern\$/";
				if( !$this->_caseSensitive )
					$regexp .= "i";
					
				$res = preg_match( $regexp, $value );
				if( $res > 0 )
					return false;	// no need to keep searching					
			}
			
			return true;
        }
    }
?>
